;CodeVisionAVR C Compiler V1.24.0 Evaluation
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATtiny26
;Clock frequency     : 4,000000 MHz
;Memory model        : Tiny
;Optimize for        : Speed
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 32 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "C.vec"
	.INCLUDE "C.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80
;       1 /*
;       2 Target : ATTiny26L
;       3 Crystal: 4.0000Mhz
;       4 
;       5    ADC  Tiny26L       (ADC5,ADC6,ADC10).
;       6    LPT(bit INIT)  .      
;       7 10-     8-   6      A,  2    B c   PB2.  
;       8    379h      , ..   ,   
;       9       - (    INT0).     . 
;      10       ,           
;      11    .
;      12 
;      13 Design by Kulev Nikita. 2004.()
;      14 */  
;      15 
;      16 #include <tiny26.h>
;      17 #include <delay.h>
;      18 
;      19 void port_init(void);
;      20 void init_devices(void);  
;      21 void adc_init(void);
;      22 void main(void);  
;      23 unsigned char counter; //     
;      24 unsigned char result;
;      25 unsigned char resa;
;      26 unsigned char resb;
;      27 
;      28 ///////////// programm /////////////////
;      29 void main(void)
;      30 {

	.CSEG
_main:
;      31  init_devices();
	RCALL _init_devices
;      32  while (1);
_0x8:
	RJMP _0x8
;      33 }
_0xB:
	RJMP _0xB
;      34 
;      35 ///////////// interrupt //////////////
;      36 
;      37 // External Interrupt 0 service routine
;      38 interrupt [EXT_INT0] void ext_int0_isr(void)
;      39 {
_ext_int0_isr:
	RCALL __SAVEISR
;      40  ADCSR|=0x40; // start conversion bit6 = 1 
	SBI  0x6,6
;      41  GIMSK = 0x00;// INT0       .
	CLR  R30
	OUT  0x3B,R30
;      42 }
	RCALL __LOADISR
	RETI
;      43 
;      44 
;      45 // ADC interrupt service routine
;      46 interrupt [ADC_INT] void adc_isr(void)
;      47 {
_adc_isr:
	RCALL __SAVEISR
;      48  ADCSR = 0x00; //disable adc
	CLR  R30
	OUT  0x6,R30
;      49  
;      50  result=ADCH; // 8-  
	IN   R5,5
;      51   
;      52  result=~result;//     .
	COM  R5
;      53  resa=result & 0b00111111;//  6 
	MOV  R30,R5
	ANDI R30,LOW(0x3F)
	MOV  R6,R30
;      54  PORTA|=resa;//   A 6   .
	IN   R30,0x1B
	OR   R30,R6
	OUT  0x1B,R30
;      55  resb=result>>6;//,       2 .
	MOV  R30,R5
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	LSR  R30
	MOV  R7,R30
;      56  PORTB|=resb;//  2    B
	IN   R30,0x18
	OR   R30,R7
	OUT  0x18,R30
;      57  DDRA=0b00111111; //     
	LDI  R30,LOW(63)
	OUT  0x1A,R30
;      58  DDRB|=0b00000011;
	IN   R30,0x17
	ORI  R30,LOW(0x3)
	OUT  0x17,R30
;      59 
;      60  PORTB|=0X04; // ,   .  .
	SBI  0x18,2
;      61  delay_ms(1);//,     INT0,         .
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      62  
;      63  while (!(PINB.6==1));//   
_0xE:
	SBIS 0x16,6
	RJMP _0xE
;      64 
;      65  DDRA=0X00;//  A   
	CLR  R30
	OUT  0x1A,R30
;      66  DDRB=0x00;//  B
	OUT  0x17,R30
;      67  PORTA = 0X00;//         . ..      . 
	OUT  0x1B,R30
;      68  PORTB = 0X00;//.    
	OUT  0x18,R30
;      69 
;      70  counter++; //   
	INC  R4
;      71 
;      72  if (counter==1) 
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0x11
;      73   {
;      74    ADMUX = 0x26;//ADC6 (   )
	LDI  R30,LOW(38)
	OUT  0x7,R30
;      75    goto exit;
	RJMP _0x12
;      76   }
;      77 
;      78  if (counter==2) 
_0x11:
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0x13
;      79   {
;      80    ADMUX = 0x2A;//ADC10
	LDI  R30,LOW(42)
	OUT  0x7,R30
;      81    goto exit;
	RJMP _0x12
;      82   }
;      83 
;      84  if (counter==3) 
_0x13:
	LDI  R30,LOW(3)
	CP   R30,R4
	BRNE _0x14
;      85   {
;      86    counter=0; 
	CLR  R4
;      87    ADMUX = 0x25;//ADC5 (   )
	LDI  R30,LOW(37)
	OUT  0x7,R30
;      88    goto exit;
;      89   }
;      90  exit:
_0x14:
_0x12:
;      91   ADCSR = 0x8D;//  
	LDI  R30,LOW(141)
	OUT  0x6,R30
;      92   GIMSK = 0x40;// IRQ 
	LDI  R30,LOW(64)
	OUT  0x3B,R30
;      93   GIFR = 0xFF; //     
	LDI  R30,LOW(255)
	OUT  0x3A,R30
;      94 }                   
	RCALL __LOADISR
	RETI
;      95 
;      96 
;      97 ////////// initialization /////////////
;      98 void init_devices(void)
;      99 { 
_init_devices:
;     100  counter = 0; // 
	CLR  R4
;     101  #asm("CLI"); //disable all interrupts
	CLI
;     102  
;     103  // Timer/Counter 0 initialization
;     104  // Clock source: System Clock
;     105  // Clock value: Timer 0 Stopped
;     106  TCCR0=0x00;
	CLR  R30
	OUT  0x33,R30
;     107  TCNT0=0x00;
	OUT  0x32,R30
;     108  // Timer/Counter 1 initialization
;     109  // Clock source: System Clock
;     110  // Clock value: Timer 1 Stopped
;     111  // Mode: Normal top=FFh
;     112  // OC1A output: Disconnected
;     113  // OC1B output: Disconnected
;     114  PLLCSR=0x00;
	OUT  0x29,R30
;     115  TCCR1A=0x00;
	OUT  0x30,R30
;     116  TCCR1B=0x00;
	OUT  0x2F,R30
;     117  TCNT1=0x00;
	OUT  0x2E,R30
;     118  OCR1A=0x00;
	OUT  0x2D,R30
;     119  OCR1B=0x00;
	OUT  0x2C,R30
;     120  OCR1C=0x00;
	OUT  0x2B,R30
;     121  // Timer(s)/Counter(s) Interrupt(s) initialization
;     122  TIMSK=0x00;
	OUT  0x39,R30
;     123 
;     124  // Universal Serial Interface initialization
;     125  // Mode: Disabled
;     126  // Clock source: Register & Counter=no clk.
;     127  // USI Counter Overflow Interrupt: Off
;     128  USICR=0x00;
	OUT  0xD,R30
;     129 
;     130  // Analog Comparator initialization
;     131  // Analog Comparator: Off
;     132  ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     133 
;     134  // INT0 Mode: Rising Edge
;     135  // Interrupt on any change on pins PA3, PA6, PA7 and PB4-7: Off
;     136  // Interrupt on any change on pins PB0-3: On
;     137  MCUCR=0b00000011;//(Rising INT0)
	LDI  R30,LOW(3)
	OUT  0x35,R30
;     138  GIFR=0b01000000;//  INT0 - bit6,  PinChange - bit5
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     139   
;     140  port_init();
	RCALL _port_init
;     141  adc_init();
	RCALL _adc_init
;     142  GIMSK = 0x40; //  
	LDI  R30,LOW(64)
	OUT  0x3B,R30
;     143  #asm("SEI"); //re-enable interrupts
	SEI
;     144 }
	RET
;     145 
;     146 void port_init(void)
;     147 {
_port_init:
;     148  PORTA=0x00;
	CLR  R30
	OUT  0x1B,R30
;     149  DDRA=0x00; //    , ..    
	OUT  0x1A,R30
;     150  PORTB=0x00;
	OUT  0x18,R30
;     151  DDRB=0x00; //    , ..    
	OUT  0x17,R30
;     152 }
	RET
;     153 
;     154 void adc_init(void)
;     155 { 
_adc_init:
;     156 // ADC Clock frequency: 125,000 kHz
;     157 // ADC Voltage Reference: AVCC pin
;     158 // Only the 8 most significant bits of
;     159 // the AD conversion result are used
;     160  ADCSR = 0x00; //disable adc
	CLR  R30
	OUT  0x6,R30
;     161  ADMUX = 0b00100101; //00101 - select adc input ADC5. 
	LDI  R30,LOW(37)
	OUT  0x7,R30
;     162                      //1     - 8 BIT(ADLAR)  
;     163                      //00    - REF = AVCC
;     164                      //00100101(0x25) - ADC5; 00100110(0x26) - ADC6; 00101010(0x2A) - ADC10;
;     165  ADCSR = 0x8D;//1000 1101
	LDI  R30,LOW(141)
	OUT  0x6,R30
;     166   /*
;     167   Bit 7 - ADEN: Enabled ADC
;     168   Bit 6 - ADSC: Start ADC (  Stop)
;     169   Bit 5 - ADFR: Non FreeRun
;     170   Bit 4 - ADIF: Interrupt Flag "1" - reset flag if "1" set 
;     171   Bit 3 - ADIE: Enabled Interrupt
;     172   Bits 2..0 - ADPS2..ADPS0: Prescaler 4000/32=125kHz
;     173   */
;     174   }
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

